
import sq4d.all;


/// D\̂pushB
/// ̊֐̓X^bNϓB
void sqd_pushstruct(S)(HSQUIRRELVM sq, auto ref S val)
    if (is(S == struct))
{
    auto table = SquirrelObject.makeTable(sq);
    foreach (i, field_; __traits(derivedMembers, T)) {
        enum field = __traits(derivedMembers, T)[i];
        //static if (isMemberVariable!(T, field)) {
        static if (isProperty!(T, field)) {
            table[field] = __traits(getMember, val, field);
        }
    }
    table.push(sq);
}

/// D\̂getB
S sqd_getstruct(S)(HSQUIRRELVM sq, int index)
    if (is(S == struct))
{
    mixin(sqd_assert_stack_is_unchanged);
    auto table = SquirrelObject.makeFromIndex(sq, index);
    S val;
    foreach (i, field_; __traits(derivedMembers, T)) {
        enum field = __traits(derivedMembers, T)[i];
        //static if (isMemberVariable!(T, field)) {
        static if (isProperty!(T, field)) {
            __traits(getMember, val, field) = table[field];
        }
    }
    return val;
}

/// \S̈Ϗpush
void sqd_structpushdelegate(S)(HSQUIRRELVM sq) {
    enum delegate_slotname = "_d_struct_delagate_" ~ S.stringof;
    sq_pushregistrytable(sq);
    sqd_getslot(sq, delegate_slotname);
        // set methods
        foreach (i, field_; __traits(derivedMembers, T)) {
            enum field = __traits(derivedMembers, T)[i];
            static if (field != "__ctor" &&
                       //isMemberFunction!(T, field) &&
                       //isAccessible!(T, field) &&
                       !isProperty!(T, field) &&
                       !isPropertyGetOnly!(T, field) &&
                       __traits(compiles, sqd_pushmethodwrapper!(T, field)(sq))) {
                //mixin printFieldAttribute!(T, field);
                pragma(msg, T.stringof~"."~field~"()");
                sqd_push(sq, field);
                sqd_pushmethodwrapper!(T, field)(sq);
                sqd_checkresult(sq_newslot(sq, -3, SQFalse), sq, "newslot");
            }
        }

    
}


