module sqstdio;

import squirrel;

extern (C):

enum SQ_SEEK_CUR = 0;
enum SQ_SEEK_END = 1;
enum SQ_SEEK_SET = 2;
alias void* SQFILE;

SQFILE sqstd_fopen(const(SQChar)*, const(SQChar)*);
SQInteger sqstd_fread(SQUserPointer, SQInteger, SQInteger, SQFILE);
SQInteger sqstd_fwrite(SQUserPointer, SQInteger, SQInteger, SQFILE);
SQInteger sqstd_fseek(SQFILE, SQInteger, SQInteger);
SQInteger sqstd_ftell(SQFILE);
SQInteger sqstd_fflush(SQFILE);
SQInteger sqstd_fclose(SQFILE);
SQInteger sqstd_feof(SQFILE);

SQRESULT sqstd_createfile(HSQUIRRELVM v, SQFILE file, SQBool own);
SQRESULT sqstd_getfile(HSQUIRRELVM v, SQInteger idx, SQFILE* file);

//compiler helpers
SQRESULT sqstd_loadfile(HSQUIRRELVM v, const(SQChar)* filename, SQBool printerror);
SQRESULT sqstd_dofile(HSQUIRRELVM v, const(SQChar)* filename, SQBool retval, SQBool printerror);
SQRESULT sqstd_writeclosuretofile(HSQUIRRELVM v, const(SQChar)* filename);

SQRESULT sqstd_register_iolib(HSQUIRRELVM v);


